
Ruby - Bug #19153

Since 2.7.7 CGI::Cookie raises ArgumentError when cookie domains is prefixed with a dot

11/26/2022 04:30 PM - cpinto (Celso Pinto)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.7.7p221 (2022-11-24 revision

168ec2b1e5) [arm64-darwin22]

Backport: 2.7: REQUIRED, 3.0: REQUIRED, 3.1:

DONE

Description

The rspec tests of our Rails app started failing with an ArgumentError after upgrading to 2.7.7. On inspection, the issue seems to be

caused by CGI::Cookie.domain=:

def domain=(str)

      if str and ((str = str.b).bytesize > 255 or !DOMAIN_VALUE_RE.match?(str))

        raise ArgumentError, "invalid domain: #{str.dump}"

      end

      @domain = str

    end

 Setting a breakpoint:

0> str

=> ".example.com"

0> DOMAIN_VALUE_RE

=> /\A(?(?!-)[-A-Za-z0-9]+(?<!-))(?:.\g)*\z/

0> DOMAIN_VALUE_RE.match?(str)

=> false

0> DOMAIN_VALUE_RE.match?('example.com')

=> true

Associated revisions

Revision 4141989b2aef2993bb19140a4be355d1c68b8be1 - 02/23/2023 03:41 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s)

656f25987cf2885104d5b13c8d3f5b7d32f1b333,98074a57ca9f3169fe9da9af6c49b636d37db16f,745dcf5326ea2c8e2047a3bddeb0fbb7e7d07649,b33

5d899fff3cc22b022c9ee2ceb636d714bf1a7: [Backport #19153]

    [ruby/cgi] Fix test_cgi_cookie_new_with_domain to pass on older

     rubies

    https://github.com/ruby/cgi/commit/05f0c58048

    ---

     test/cgi/test_cgi_cookie.rb | 8 ++++----

     1 file changed, 4 insertions(+), 4 deletions(-)

    [ruby/cgi] Prepare to release 0.3.6

    https://github.com/ruby/cgi/commit/710a647855

    ---

     lib/cgi.rb | 2 +-

     1 file changed, 1 insertion(+), 1 deletion(-)

    [ruby/cgi] Loosen the domain regex to accept '.'

     (https://github.com/ruby/cgi/pull/29)

    * Loosen the domain regex to accept '.'

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

    https://github.com/ruby/cgi/commit/5e09d632f3
    Co-authored-by: Hiroshi SHIBATA <hsbt@ruby-lang.org>

    ---

     lib/cgi/cookie.rb           | 2 +-

     test/cgi/test_cgi_cookie.rb | 3 +++

     2 files changed, 4 insertions(+), 1 deletion(-)

    [ruby/cgi] Bump up 0.3.6

    https://github.com/ruby/cgi/commit/827b7d43cc

    ---

     lib/cgi.rb | 2 +-

     1 file changed, 1 insertion(+), 1 deletion(-)

Revision 4141989b2aef2993bb19140a4be355d1c68b8be1 - 02/23/2023 03:41 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s)

656f25987cf2885104d5b13c8d3f5b7d32f1b333,98074a57ca9f3169fe9da9af6c49b636d37db16f,745dcf5326ea2c8e2047a3bddeb0fbb7e7d07649,b33

5d899fff3cc22b022c9ee2ceb636d714bf1a7: [Backport #19153]

    [ruby/cgi] Fix test_cgi_cookie_new_with_domain to pass on older

     rubies

    https://github.com/ruby/cgi/commit/05f0c58048

    ---

     test/cgi/test_cgi_cookie.rb | 8 ++++----

     1 file changed, 4 insertions(+), 4 deletions(-)

    [ruby/cgi] Prepare to release 0.3.6

    https://github.com/ruby/cgi/commit/710a647855

    ---

     lib/cgi.rb | 2 +-

     1 file changed, 1 insertion(+), 1 deletion(-)

    [ruby/cgi] Loosen the domain regex to accept '.'

     (https://github.com/ruby/cgi/pull/29)

    * Loosen the domain regex to accept '.'

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

    https://github.com/ruby/cgi/commit/5e09d632f3

    Co-authored-by: Hiroshi SHIBATA <hsbt@ruby-lang.org>

    ---

     lib/cgi/cookie.rb           | 2 +-

     test/cgi/test_cgi_cookie.rb | 3 +++

     2 files changed, 4 insertions(+), 1 deletion(-)

    [ruby/cgi] Bump up 0.3.6

    https://github.com/ruby/cgi/commit/827b7d43cc

    ---

     lib/cgi.rb | 2 +-

     1 file changed, 1 insertion(+), 1 deletion(-)

Revision 4141989b - 02/23/2023 03:41 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s)

656f25987cf2885104d5b13c8d3f5b7d32f1b333,98074a57ca9f3169fe9da9af6c49b636d37db16f,745dcf5326ea2c8e2047a3bddeb0fbb7e7d07649,b33

5d899fff3cc22b022c9ee2ceb636d714bf1a7: [Backport #19153]

    [ruby/cgi] Fix test_cgi_cookie_new_with_domain to pass on older

     rubies

    https://github.com/ruby/cgi/commit/05f0c58048

    ---

     test/cgi/test_cgi_cookie.rb | 8 ++++----

     1 file changed, 4 insertions(+), 4 deletions(-)

    [ruby/cgi] Prepare to release 0.3.6

    https://github.com/ruby/cgi/commit/710a647855

    ---

     lib/cgi.rb | 2 +-

     1 file changed, 1 insertion(+), 1 deletion(-)
    [ruby/cgi] Loosen the domain regex to accept '.'

     (https://github.com/ruby/cgi/pull/29)

    * Loosen the domain regex to accept '.'

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

    https://github.com/ruby/cgi/commit/5e09d632f3

    Co-authored-by: Hiroshi SHIBATA <hsbt@ruby-lang.org>

    ---

     lib/cgi/cookie.rb           | 2 +-

     test/cgi/test_cgi_cookie.rb | 3 +++

     2 files changed, 4 insertions(+), 1 deletion(-)

    [ruby/cgi] Bump up 0.3.6

    https://github.com/ruby/cgi/commit/827b7d43cc

    ---

     lib/cgi.rb | 2 +-

     1 file changed, 1 insertion(+), 1 deletion(-)

History

#1 - 11/26/2022 05:00 PM - mame (Yusuke Endoh)

This issue is discussed at https://github.com/ruby/cgi/pull/29 .

As I wrote in https://github.com/ruby/cgi/pull/29#issuecomment-1325852303, RFC 6265 prohibits leading dot for Cookie domain. However, the old

spec of Cookie (RFC 2109) required the leading dot. I think it is reasonable to allow leading dots.

@akr (Akira Tanaka) @naruse (Yui NARUSE) What do you think?

#2 - 11/28/2022 04:45 AM - hsbt (Hiroshi SHIBATA)

FYI: https://github.com/ruby/cgi/pull/29#issuecomment-1328487556

I released cgi-0.3.6 for this issue. Can you try it with adding "cgi", ">= 0.3.6" in your Gemfile?

#3 - 11/28/2022 04:51 AM - mame (Yusuke Endoh)

mame (Yusuke Endoh) wrote in #note-1:

As I wrote in https://github.com/ruby/cgi/pull/29#issuecomment-1325852303, RFC 6265 prohibits leading dot for Cookie domain. However, the

old spec of Cookie (RFC 2109) required the leading dot. I think it is reasonable to allow leading dots.

 Just for the record: it looks like RFC 6265 allows a leading dot. See https://github.com/ruby/cgi/pull/29#issuecomment-1328487556

#4 - 11/28/2022 05:36 AM - hsbt (Hiroshi SHIBATA)

- Status changed from Open to Closed

- Backport changed from 2.7: UNKNOWN, 3.0: UNKNOWN, 3.1: UNKNOWN to 2.7: REQUIRED, 3.0: REQUIRED, 3.1: REQUIRED

#5 - 02/23/2023 03:42 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.7: REQUIRED, 3.0: REQUIRED, 3.1: REQUIRED to 2.7: REQUIRED, 3.0: REQUIRED, 3.1: DONE

ruby_3_1 4141989b2aef2993bb19140a4be355d1c68b8be1 merged revision(s)

656f25987cf2885104d5b13c8d3f5b7d32f1b333,98074a57ca9f3169fe9da9af6c49b636d37db16f,745dcf5326ea2c8e2047a3bddeb0fbb7e7d07649,b33

5d899fff3cc22b022c9ee2ceb636d714bf1a7.

#6 - 02/23/2023 03:43 AM - nagachika (Tomoyuki Chikanaga)

Updated the bundled cgi to 0.3.6 on ruby_3_1 branch.
